

#declare wood1=texture{
        pigment {
                wood turbulence 0.1
                color_map{
                        [0.7 color rgb <0.6,0.5,0>]
                        [0.9 color rgb <0.5,0.4,0>]
                        }
                }
        normal {wood 0.1 turbulence 0.1}
        finish {ambient 0.3}               
        scale 0.2
        }
                 




#declare firelight=
        light_source
        {
                <0, 0, 0>
                color rgb <0.3,0.2,0>
                fade_distance 5
                fade_power 2
                
                
        }
        
        
        
#declare Density2=
  density {
    spherical
    ramp_wave 
    color_map {
      [0.0 color rgb <0, 0, 0.0>]
      [0.10 color rgb <2, 1.5, 0.0>]
      [0.13 color rgb <5, 3, 0.0>]
      [0.17 color rgb <0.5, 0.5, 0.0>]
      [0.7 color rgb <2, 2, 0>]
      [1.0 color rgb <20, 20, 20>]
    } 
  }


#declare shine=
sphere { 0, 2
  pigment { color rgbf<1, 1, 1, 1> }
  finish { ambient 1 diffuse 0 }
  interior { 
    media {
      emission 0.2
      intervals 5
      samples 1, 10
      confidence 0.9999
      variance 1/1000
      density {
        Density2
      }
    } 
  }
  //translate -1.25*x
  scale 3
  hollow 
}	

#declare ls=0.8
#declare lwand=union{
cylinder {<ls,0,ls> <1,2,1> 0.1}
cylinder {<ls,0,ls> <-1,2,1> 0.06}
cylinder {<1,2,1> <-ls,0,ls> 0.06}
cylinder {<1,2,1> <-1,2,1> 0.1}
cylinder {<ls,0,ls> <-ls,0,ls> 0.1}
sphere {<ls,0,ls> 0.1}
}
#declare lcorpus= union {
object {lwand}
object {lwand rotate y*90}
object {lwand rotate y*180}
object {lwand rotate y*270}
box {<-ls,-0.05,-ls> <ls,0.05,ls>}
translate y*-1
pigment {color rgb <1,0.6,0.5>}
normal {agate 0.2}
}

#declare chdim=0.2;
#declare chhgt=0.15;
#declare chsld=0.07;
#declare chtrans=(chdim+chhgt)*2-chsld*2;
#declare halftorus=difference{
	torus{chdim,chsld}
	box{<-chdim*2,-chdim*2,0> < chdim*2,chdim*2,chdim*2>}
	rotate x*90
	translate y* chhgt
	}
#declare chainpiece=union{
	object {halftorus }
	object {halftorus rotate z*180 }
	cylinder{<-chdim,-chhgt,0><-chdim,chhgt,0> chsld}
	cylinder{< chdim,-chhgt,0>< chdim,chhgt,0> chsld}
	}
#declare chainsegment=union{
	object{chainpiece}
	object {chainpiece rotate y*90 translate y*chtrans}
	}
	
#declare mychain=union{
	object{chainsegment}
	object {chainsegment translate y*chtrans*2}
	object {chainsegment translate y*chtrans*4}
	object {chainsegment translate y*chtrans*6}
	}
#declare dw=0.9;
#declare dach=union{
prism {  
	linear_spline  
	conic_sweep
	0, 2, 10,  
	<-1,-1>, <-1,1>, <1,1>, <1,-1>, <-1,-1>  //outer rim
	<-dw,-dw>, <-dw,dw>, <dw,dw>, <dw,-dw>, <-dw,-dw>  //inner rim  
	translate y*-2
	rotate x*180
	}
	
	union{
		sphere {<-2,0,-2> 0.1}
		sphere {<-2,0,2> 0.1}
		sphere {<2,0,-2> 0.1}
		sphere {<2,0,2> 0.1}
		
		cylinder {<-2,0,-2> <-2,0,2> 0.1}
		cylinder {<-2,0,2> <2,0,2> 0.1}
		cylinder {<2,0,2> <2,0,-2> 0.1}
		cylinder {<2,0,-2> <-2,0,-2> 0.1}
	
		cylinder {<-2,0,-2> <0,2,0> 0.1}
		cylinder {<-2,0,2> <0,2,0> 0.1}
		cylinder {<2,0,2> <0,2,0> 0.1}
		cylinder {<2,0,-2> <0,2,0> 0.1}
		
		sphere {<0,2,0> 0.5}
		
		translate y*-0.1
		}
	pigment {color rgb <0.2,0.25,0.3>}
	normal {crackle scale 0.5}
	finish {phong 1}
	scale 0.7
	translate y*dw
	 
	}
	
	
	
	
#declare mylaterne=
union{
	object{mychain translate y*(2.5+chdim) rotate y*20 
		pigment {color rgb 0.3}
		finish {phong 1}
		}
	object{lcorpus}
	
	object{shine}
	light_source{firelight}	
	object{dach} 
	
	rotate y*30
	rotate x*0
	translate y*-2.5
	translate y*-(chtrans*8)
	scale 0.5
        no_shadow	
}
	
	
	
	
#declare woodpad=
difference{
union{
	cylinder {<0,-1,-0.1> <0,-1,0.1> 0.7}
	cylinder {<0,0,-0.1> <0,0,0.1> 0.85 scale <1,1.3,1>}
	cylinder {<0,1,-0.1> <0,1,0.1> 0.7}
	torus{0.7,0.1 rotate x*90 translate y*-1}
	torus{0.85,0.1 rotate x*90 scale <1,1.3,1>}
	torus{0.7,0.1 rotate x*90 translate y*1}
	}
	difference{
		union{
			torus{0.7*0.8,0.05 rotate x*90 translate <0,-1,-0.1>}
			torus{0.7*0.8,0.05 rotate x*90 translate <0,1,-0.1>}
			}
		cylinder {<0,0,-0.2> <0,0,0.2> 0.85*0.8-0.05 scale <1,1.3,1>}
		}
	difference{
		torus{0.85*0.8,0.05 rotate x*90 translate <0,0,-0.1> scale <1,1.3,1>}
		cylinder {<0,1,-0.2> <0,1,0.2> 0.7*0.8-0.05}
		cylinder {<0,-1,-0.2> <0,-1,0.2> 0.7*0.8-0.05}
		}
		
}
#declare woodarm=
union{
difference{
	union{
		cylinder{<-0.1,0,-1> <0.1,0,-1> 2}
		torus{2,0.1 rotate z*90 translate z*-1}
		}
	cylinder{<-1,-0.5,-2> <1,-0.5,-2> 2}
	box{<-1,-2,0><1,2,2>}
	box{<-1,-0.5,-1><1,-5,1>}
	
	
	}
	difference{
		torus{2,0.1 rotate z*90 translate <0,-0.5,-2>}
		box{<-1,-2,-2.45><1,2,-5>}
		box{<-1,-0.5,-5><1,-3,1>}
		}
	sphere{<0,-0.5,0> 0.1}
	translate <0,-0.7,-0.1>
}	
#declare woodball=sphere{<0,0.8,-2.45> 0.2}



#declare model=
union{
	object{woodarm texture {wood1 rotate x*30}}
	object {woodpad texture {wood1 rotate x*80}}
	object {woodball texture {wood1 rotate 45}}
	object {mylaterne translate <0,0.8,-2.45>}
	}

